import _extends from "@babel/runtime/helpers/esm/extends";
import { area, line } from 'd3-shape';
import React from 'react';
import { clampPxToAxis, getPrimary, getSecondary, getSecondaryStart, getX, getY, translate } from '../utils/Utils';
import useChartContext from '../utils/chartContext'; //

import { monotoneX } from '../utils/curveMonotone';
export default function AreaComponent(_ref) {
  var _secondaryAxis$curve;

  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = useChartContext(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      focusedDatumState = _useChartContext.focusedDatumState,
      gridDimensions = _useChartContext.gridDimensions;

  var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : monotoneX;
  var focusedDatum = focusedDatumState[0];
  return /*#__PURE__*/React.createElement("g", {
    style: {
      transform: translate(gridDimensions.left, gridDimensions.top)
    }
  }, allSeries.map(function (series, i) {
    var _area$curve, _line$curve;

    var style = getSeriesStatusStyle(series, focusedDatum);

    var lineStyle = _extends({
      strokeWidth: 2
    }, style, style.line, {
      fill: 'none'
    });

    var areaStyle = _extends({
      strokeWidth: 2,
      opacity: 0.5
    }, style, style.area);

    var areaPath = (_area$curve = area(function (datum) {
      var _getPrimary;

      return (_getPrimary = getPrimary(datum, primaryAxis)) != null ? _getPrimary : NaN;
    }, function (datum) {
      var _getSecondaryStart;

      return clampPxToAxis((_getSecondaryStart = getSecondaryStart(datum, secondaryAxis)) != null ? _getSecondaryStart : NaN, secondaryAxis);
    }, function (datum) {
      var _getSecondary;

      return clampPxToAxis((_getSecondary = getSecondary(datum, secondaryAxis)) != null ? _getSecondary : NaN, secondaryAxis);
    }).curve(curve)(series.datums)) != null ? _area$curve : undefined;
    var linePath = (_line$curve = line(function (datum) {
      var _getPrimary2;

      return (_getPrimary2 = getPrimary(datum, primaryAxis)) != null ? _getPrimary2 : NaN;
    }, function (datum) {
      var _getSecondary2;

      return (_getSecondary2 = getSecondary(datum, secondaryAxis)) != null ? _getSecondary2 : NaN;
    }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
    return /*#__PURE__*/React.createElement("g", {
      key: "lines-" + i
    }, /*#__PURE__*/React.createElement("path", {
      d: areaPath,
      style: areaStyle
    }), /*#__PURE__*/React.createElement("path", {
      d: linePath,
      style: lineStyle
    }), series.datums.map(function (datum, i) {
      var _getY, _secondaryAxis$showDa;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/React.createElement("circle", {
        key: i,
        ref: function ref(el) {
          datum.element = el;
        },
        r: 2,
        cx: getX(datum, primaryAxis, secondaryAxis),
        cy: (_getY = getY(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN,
        stroke: "rgba(33,33,33,0.5)",
        style: _extends({
          // @ts-ignore
          r: 2
        }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : false) ? {
          opacity: 0
        } : {})
      });
    }));
  }));
}